import * as d3 from 'd3';
import { SvgElement, SVG_ELEMENT_TYPE } from './svg-element';
import { Point } from './point';
export interface AxisOptions {
    tickInterval?: number;
    extraSpace?: number;
    disableAxisTitle?: boolean;
    disableAxisLine?: boolean;
    disableTickLine?: boolean;
    disableTickMark?: boolean;
    disableTickNumber?: boolean;
}
export declare class Axis extends SvgElement {
    private unit;
    defaultOptions: AxisOptions;
    options: AxisOptions;
    private tickValues;
    private domain;
    private range;
    private scale;
    private axis;
    constructor(type: SVG_ELEMENT_TYPE, name: string, unit: string, options?: AxisOptions);
    setRange(r: [number, number]): void;
    setDomain(domain: [number, number]): void;
    resetDomainWithPoint(first: Point, last: Point): void;
    readonly title: string;
    getScale(): d3.ScaleLinear<number, number>;
    applyAxisOptions(options: AxisOptions): void;
    private calculateTickValues();
    private validDomain();
    private createAxisAndScale();
    private appendAxisTitle();
    private appendTickLine(noZeroTick?, hasLastTick?);
    buildGroup(): void;
    getSize(): ClientRect;
    private disableAxisLine();
    private disableTickMark();
    private disableTickNumber();
}
