import * as d3 from 'd3';
export var d3_util;
(function (d3_util) {
    function getRect(selector) {
        return selector.node().getBoundingClientRect();
    }
    d3_util.getRect = getRect;
    function createGroup(tag) {
        if (tag === void 0) { tag = 'g'; }
        return d3.select(document.createElementNS(d3.namespaces.svg, tag));
    }
    d3_util.createGroup = createGroup;
    function createEqTriangle(sideLength, centerPosition) {
        var pi = 3.141592653589793238462643383;
        var halfSide = sideLength / 2;
        var innerHypotenuse = halfSide * (1 / Math.cos(30 * pi / 180));
        var innerOpposite = halfSide * (1 / Math.tan(60 * pi / 180));
        var left = [centerPosition[0] - halfSide, centerPosition[1] + innerOpposite];
        var right = [centerPosition[0] + halfSide, centerPosition[1] + innerOpposite];
        var top = [centerPosition[0], centerPosition[1] - innerHypotenuse];
        return [top, left, right];
    }
    d3_util.createEqTriangle = createEqTriangle;
})(d3_util || (d3_util = {}));
//# sourceMappingURL=d3.util.js.map