import { Canvas } from './canvas';
import { SvgElement } from './svg-element';
import { Point, PointShape } from './point';
export declare enum PathType {
    CURVED_LINE = "CurvedLine",
    STRAIGHT_LINE = "StraightLine",
}
export declare class Path extends SvgElement {
    parent: Canvas;
    axisStep: number;
    hasDot: boolean;
    pathType: PathType;
    pointShape: PointShape;
    private points;
    private xRef;
    private yRef;
    constructor(points: Point[], name?: string);
    private sort();
    color: string;
    readonly xFirst: Point;
    readonly xLast: Point;
    readonly yFirst: Point;
    readonly yLast: Point;
    setPoints(points: Point[]): void;
    private setDefaultStyle();
    buildGroup(): void;
    private _buildCurvedPath();
    private _toXY(x, y);
}
