import * as d3 from 'd3';
export declare enum SVG_ELEMENT_TYPE {
    CANVAS = "Canvas",
    AXIS_X = "AxisX",
    AXIS_Y = "AxisY",
    LEGEND = "Legend",
    PATH = "Path",
}
export declare type d3Element = d3.Selection<d3.BaseType, {}, null, undefined>;
export declare abstract class SvgElement {
    type: SVG_ELEMENT_TYPE;
    name: string;
    parent: SvgElement;
    protected children: SvgElement[];
    protected attrs: {
        [key: string]: any;
    };
    protected styles: {
        [key: string]: any;
    };
    group: d3.Selection<d3.BaseType, {}, null, undefined>;
    size: RectangleSize;
    constructor(type: SVG_ELEMENT_TYPE, name?: string);
    setAttr(name: string, value: any): this;
    delAttr(name: string): void;
    setStyle(name: string, value: any): this;
    getStyle(name: string): any;
    delStyle(name: string): void;
    protected addChild(child: SvgElement): SvgElement;
    abstract buildGroup(): void;
    applyStyle(): void;
    clearAll(): void;
    clear(): void;
    rebuild(child: SvgElement): void;
}
export declare type RectangleSize = {
    left?: number;
    top?: number;
    right?: number;
    bottom?: number;
    width?: number;
    height?: number;
};
export declare const Rect: {
    left: Function;
    top: Function;
    right: Function;
    bottom: Function;
    width: Function;
    height: Function;
};
